/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_ANDAR                                           			      */
/* Tabela : ANDAR                                                           			    	      */
/*                                                                           				      */
/* Criao:                                                             				      */
/* 28/10/2004 - Rafael dos Santos Lopes                           				      */
/*                                                                      					      */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ANDAR
BEFORE INSERT OR UPDATE OR DELETE
ON ANDAR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUANDA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMANDAR,0) <> NVL(:NEW.NMANDAR,0)) THEN
         :NEW.DTULTATUANDA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ANDAR', :OLD.CDFILIAL, 'CDANDAR='||:OLD.CDANDAR||';CDFILIAL='||:OLD.CDFILIAL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ANDAR MODIFY DTULTATUANDA DEFAULT SYSDATE
/

